/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*	"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.	*
*									*
*  Copyright (C) 1985, 1992 Lugaru Software Ltd.  All rights reserved.	*
*									*
* Limited permission is hereby granted to reproduce and modify this	*
* copyrighted material provided that the resulting code is used only in	*
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.				*
************************************************************************/

#include "eel.h"

#ifdef UNIX		/* i-search redoes cmd unless \r or ENDER */
#define ENDER	'\r'		/* only \r: return replaces ESC */
#else
#define ENDER	ESC		/* allow both */
#endif

#define FHERE	1	/* s_code: where to start searching from */
#define FORIG	2
#define FMATCH	3	/* from last match */
#define FMADD	4	/* same, but indicates we added a char this time */
#define FMREGEX	5	/* same, but in regex mode */

search_read(trystr, prmpt, flags)
char *trystr, *prmpt;
{
	int lastok, goodchars, oldflags, mstart, origwin = window_handle;
	int editbuf, pbuf, pwin, editwin, s_code, okpoint, orig, ostart;

	if (_doing_input == DI_SEARCH)
		error_if_input(0);
	save_var iter, has_arg, this_cmd, prev_cmd;
	save_var _doing_input = DI_SEARCH;
	save_var last_index;
	goodchars = lastok = 0;	/* 2 versions of len of last good string */
				/* (only lastok is set by getting default) */
	orig = okpoint = mstart = point;
	ostart = window_start;

	editbuf = tmp_buf();		/* make buffer for cmd line editing */
	pwin = add_popup(0, screen_lines - 1, screen_cols - 1, 1, 0,
			pbuf = tmp_buf());	/* prompt in window */
	stuff(trystr);
	display_column = 0;
	system_window = 1;	/* don't let user switch to it */
	text_color = color_class echo_area;

	editwin = add_popup(1, screen_lines - 1, screen_cols - 1, 1,
			0, editbuf);	/* window on top of prompt window */
	text_color = color_class echo_area;
	_display_class = _echo_disp_class;
	display_column = 0;

	for (;;) {
		show_search_prompt(prmpt, flags, origwin, pwin, editwin);
		getkey();
		if (key == CTRL('^'))
			full_getkey("", CTRLIFY_KEY);
		window_handle = editwin;
		s_code = 0;
		oldflags = flags;
		flags &= ~(BAD | FAILING | SONCE);	/* assume ok */
		if (is_search_dir()) {
			window_handle = origwin;
			point = okpoint;
			window_handle = editwin;
			if ((key == CTRL('R')) != ((flags & REVERSE) != 0)) {
				flags ^= REVERSE;	/* switch dir */
				if (goodchars)
					flags |= SONCE;
			} else if (!size()) {
				if (flags & UNKNOWN)
					flags = known_flags(flags);
get_defaults:			stuff((flags & REGEX) ? _default_regex_search
					: _default_search);
				lastok = size();
			} else if (oldflags & FAILING)
				flags |= FAILING; /* maybe search again */
			else
				flags |= SONCE;
			if ((flags & (INCR | SONCE)) && !(flags & FAILING))
				flags |= SONCE, s_code = FHERE;
		} else if (set_flag_modes(&flags)) {
			if (flags & INCR) /* if modes changed, search again */
				s_code = FMATCH;
		} else if (key == CTRL('O')) {
			flags ^= INCR;
			point = size();
			if (flags & INCR)
				s_code = FMATCH;
		} else if (reg_tab[key] == (short) help)
			help_on_command(help_on_search(flags));
		else if (key == '\n' || key == '\r' || key == GREYENTER) {
			if (oldflags & SONCE)
				flags |= SONCE;
			break;
		} else if (reg_tab[key] == (short) backward_delete_character
						&& (flags & INCR)) {
			run_topkey();
			window_handle = editwin;
			if (!(oldflags & FAILING) || size() <= lastok)
				s_code = FORIG;
			else		/* don't bother searching */
				flags |= FAILING;
		} else if (key == abort_key && (oldflags &
					((flags & INCR) ? FAILING : SONCE))) {
			if (flags & INCR)
				delete(goodchars, size());
		} else if (user_abort || (flags & INCR) && exit_incr())
			break;
		else {
			flags &= ~UNKNOWN;
			if (key == '\t')
				normal_character();
			else
				run_topkey();
			window_handle = editwin;
			if (flags & INCR)
				if (flags & (REGEX | WORD))
					s_code = FMREGEX;
				else if (oldflags & FAILING)
					flags |= FAILING;
				else
					s_code = FMADD;
		}
		user_abort = 0;
		grab(0, FNAMELEN - 1, trystr);
		if (!s_code)
			continue;
		window_handle = origwin;
		if (s_code == FORIG || s_code == FMREGEX)
			point = orig;
		else if (s_code >= FMATCH) {
			point = mstart;
			if (flags & REVERSE)
				point++;
		}
		switch (do_searching(flags, trystr)) {
			case DSBAD:
				flags = BAD | (flags & ~INCR);
			case 0:	flags |= FAILING;
				point = okpoint;
				if (in_macro()) {
					show_search_prompt(prmpt, flags,
						origwin, pwin, editwin);
					refresh();
					goto end;
				} else if (!(oldflags & FAILING))
					maybe_ding(bell_on_search);
				break;
			case 1:	okpoint = point;
				mstart = matchstart;
				window_handle = editwin;
				goodchars = lastok = size();
				break;
			case DSABORT:
				point = okpoint;
				window_handle = editwin;
				if ((flags & INCR) && s_code == FMADD)
					delete(size() - 1, size());
				break;
		}
	}
	window_handle = origwin;
	if (key == abort_key || user_abort)
		point = orig, window_start = ostart;
	else {
		window_handle = editwin;
		if (size()) {
			_last_was_regex = ((flags & REGEX) != 0);
			*(_last_was_regex ? &_default_regex_flags
				: &_default_flags) = (flags & (SMODES | INCR));
			grab(0, FNAMELEN - 1, _last_was_regex
				? _default_regex_search : _default_search);
		}
		if ((flags & INCR) && key != '\r' && key != ENDER
		    && key != GREYENTER)
			ungot_key = key;
	}
end:	window_handle = origwin;
	remove_window(editwin);
	remove_window(pwin);
	buf_delete(editbuf);
	buf_delete(pbuf);
	if ((flags & FAILING) && in_macro())
		quick_abort();
	check_abort();
	say("");
	maybe_refresh();	/* put cursor back in prev window */
	return flags;
}

char *help_on_search(flags)	/* give help on correct command */
{
	if (flags & GREP)
		return "grep";
	else if (flags & REGEX)
		return (flags & REPLACE) ? "regex-replace"
				: "regex-search";
	else
		return !(flags & REPLACE) ? "incremental-search"
				: (flags & QUERY) ? "query-replace"
				: "replace-string";
}

exit_incr()	/* does this key exit an incremental search? */
{
	return key != '\t' && key != CTRL('Q') && !norm_binding()
		&& (key < ' ' || key > DEL);
}

norm_binding()	/* does this key run normal-character? */
{
	return (mode_keys[key] ? mode_keys[key] : root_keys[key])
			== (short) normal_character;
}

set_flag_modes(fp)	/* maybe set *fp from key, return 1 if we could */
int *fp;
{
	if (key == CTRL('C')) {
		*fp ^= FOLD;
		*fp |= MODFOLD;
		return 1;
	} else if (key == CTRL('W'))
		*fp ^= WORD;
	else if (key == CTRL('T')) {
		*fp ^= REGEX;
		if (*fp | REGEX) /* if entering regex, not incremental */
			*fp &= ~INCR;
	} else
		return 0;
	if (*fp & UNKNOWN)	/* setting regex or word makes type known */
		*fp &= ~(INCR | UNKNOWN);
	return 1;
}

is_search_dir()	/* return 1 if it's a direction key inside search */
{		/* also replace with standard key value */
	if (key == CTRL('R') || key == ALT(CTRL('R'))
					|| key == rev_search_key)
		key = CTRL('R');
	else if (key == CTRL('S') || key == ALT(CTRL('S'))
					|| key == fwd_search_key)
		key = CTRL('S');	/* substitute standard one */
	else
		return 0;
	return 1;
}

known_flags(flags)	/* set flags when user pulls in default string */
{
	int def, new;

	flags &= ~(SMODES | UNKNOWN);
	def = _last_was_regex ? _default_regex_flags : _default_flags;
	new = flags | (def & ~INCR);	/* no incr if grep, e.g., calls */
	if ((flags & REGEX) && !(def & INCR))
		new &= ~INCR;	/* only allow explicit incr regex search */
	if (((new & FOLD) != 0) != case_fold.default)
		new |= MODFOLD;
	return new;
}

make_search_prompt(s, flags)
char *s;
{
	sprintf(s, "%s%s%s%s%s%s",
		(flags & BAD) ? "Bad " : (flags & FAILING) ? "Failing " : "",
		(flags & REVERSE) ? "Reverse " : "",
		!(flags & MODFOLD) ? "" :
				(flags & FOLD) ? "Folding " : "Exact ",
		(flags & REGEX) ? "R-E " : "",
		(flags & WORD) ? "Word " : "",
		(flags & INCR) ? "I-" : "");
}

show_search_prompt(prmpt, flags, origwin, pwin, editwin)
char *prmpt;
{
	char tmp[80];

	window_handle = pwin;
	buf_zap(bufnum);
	make_search_prompt(tmp, flags);
	stuff(tmp);
	stuff(prmpt);
	point = 0;
	set_wattrib(editwin, BLEFT, size());	/* reset window edges */
	window_handle = (flags & (INCR | SONCE)) ? origwin : editwin;
	maybe_refresh();
}

/* string-search command */
command regex_search() on reg_tab[ALT(CTRL('S'))]
{
	conv_search(REGEX);
}

/* reverse-string-search backward */
command reverse_regex_search() on reg_tab[ALT(CTRL('R'))]
{
	conv_search(REGEX | REVERSE);
}

command incremental_search() on reg_tab[CTRL('S')]
{
	conv_search(UNKNOWN | INCR);
}

command reverse_incremental_search() on reg_tab[CTRL('R')]
{
	conv_search(UNKNOWN | INCR | REVERSE);
}

command string_search()
{
	conv_search(0);
}

command reverse_string_search()
{
	conv_search(REVERSE);
}

get_search_string(pr, flags)	/* prompt for search string & return flags */
char *pr;
{
	char tmp[FNAMELEN];

	flags = default_fold(flags);
	*tmp = 0;
	return search_read(tmp, pr, flags);
}

conv_search(flags) /* prompt for search string, then search, but see flags */
{
	char *s;
	int orig, ret;

	flags = get_search_string("Search: ", flags);
	s = (flags & REGEX) ? _default_regex_search : _default_search;
	if (!(flags & (INCR | SONCE)))
		while (iter-- > 0) {
			orig = point;
			ret = do_searching(flags, s);
			if (ret == 1)
				continue;
			if (ret == DSABORT)
				say("Search aborted");
			else {
				say("%s: not found", s);
				point = orig;
				if (in_macro())
					quick_abort();
			}
			break;
		}
	iter = 0;
}

default_fold(flags)		/* initialize flag from buffer variable */
{
	if (case_fold)
		flags |= FOLD;
	if (case_fold != case_fold.default)
		flags |= MODFOLD;
	return flags;
}

command replace_string() on reg_tab[ALT('&')]
{
	gen_replace(0);
}

command query_replace() on reg_tab[ALT('%')], reg_tab[ALT('r')]
{
	gen_replace(QUERY);
}

command regex_replace() on reg_tab[ALT('*')], reg_tab[NUMALT(GREYSTAR)]
{
	gen_replace(QUERY | REGEX);
}

gen_replace(flags)	/* get input, then do replace */
{
	char str[FNAMELEN], with[FNAMELEN], *s;
	
	iter = 0;
	if (has_arg)
		flags |= WORD;
	*str = 0;
	flags = default_fold(flags);
	flags = search_read(str, (flags & QUERY) ? "Query replace string: "
				: "Replace string: ", flags | REPLACE);
	flags &= ~(INCR | FAILING | BAD | REVERSE);
	if (*str) {
		s = (flags & REGEX) ? _default_regex_replace
			: _default_replace;
		last_index = find_index(help_on_search(flags));
		get_strnone(with, "with: ", s);
		strcpy(s, with);
		show_replace(str, with, flags);
		string_replace(str, with, flags | INCR);
	}
}

show_replace(str, with, flags)	/* print in echo area */
char *str, *with;
{
	char msg[FNAMELEN];

	make_search_prompt(msg, flags);
	if (flags & BAD) {
		say("%sReplace %s", msg, str);
		return;
	}
	strcat(msg, "Replacing ");
	strcat(msg, str);
	strcat(msg, " with ");
	strcat(msg, with);
	if (flags & QUERY)
		note("%s", msg);
	else
		noteput("%s", msg);
}

/* General replace routine. */

/* Interprets flag INCR to mean "interactive, show results". */

/* Returns DSABORT if the user aborted, DSBAD if illegal search string, */
/* 1 if user said to exit early, or 0 if we got to the last match. */

string_replace(str, with, flags)
char *str, *with;
{
	spot orig = alloc_spot(), prev = alloc_spot(), oldmark;
	int skip = 0, show = 0, ret, evershow = 0, found = 0, changed = 0;

	for (;;) {
		skip = 0;
		*prev = point;
		ret = do_searching(flags, str);
		if (!ret || ret == DSBAD) {
			point = *orig;
			break;
		} else if (ret == DSABORT)
			break;
		found++;
ask:		if (show) {
			show_replace(str, with, (flags & ~INCR));
			evershow = 1;
			show = 0;
		}
		if (!(flags & QUERY)) goto do_replace;
		maybe_refresh();		/* show the selection */
		getkey();
		if (key == CTRL('^'))
			full_getkey("", CTRLIFY_KEY);
		user_abort = 0;
		if (key == '?' || key == 'h'
					|| root_keys[key] == (short) help) {
			help_on_command("query-replace");
			show = 1;
			goto ask;
		} else if (user_abort || key == abort_key) {
			point = *orig;
			ret = DSABORT;
			goto done;
		}
		switch(tolower(key)) {
			case '^': point = *prev;
			case '\b':
			case 'n': skip = 1;	/* go to the next match */
			case ' ':
			case 'y':		/* do the replace */
			case '!':
			case ',':
			case '.': break;
			case CTRL('R'):
				say("");
				oldmark = alloc_spot();
				*oldmark = mark;	/* save mark */
				mark = point - strlen(skip? with: str);
					/* set temporary mark before text */
				recursive_edit();
				mark = *oldmark;	/* restore mark */
				free_spot(oldmark);
				show = 1;
				continue;
			default:	if (set_flag_modes(&flags)) {
						show = 1;
						goto ask;
					}
					if (key != '\r' && key != ENDER
					    && key != GREYENTER)
						ungot_key = key;
			case ESC:	ret = 1; goto done;
		}
do_replace:	if (!skip) {
			if (flags & REGEX)
				fromorig(with);
			else {
				delete(point - strlen(str), point);
				stuff(with);
			}
			changed++;
		}
		if (flags & QUERY)
			switch (key) {
			case ',': case '^':	skip = 1; goto ask;
			case '.':		ret = 1; goto done;
			case '!':		flags &= ~QUERY; show = 1;
			}
	}
done:
	if (ret == DSABORT)
		say("Replacement aborted");
	else if (ret == DSBAD) {
		show_replace(str, with, (flags & ~INCR) | BAD);
	} else if (evershow || (flags & INCR))
		say("Replaced %d of %d.", changed, found);
	free_spot(orig);
	free_spot(prev);
	return ret;
}

do_searching(flags, str)	/* search according to flags */
char *str;	/* return 0=not found, 1=found, 2=aborted, 3=bad pattern */
{
	jmp_buf *old_level = top_level, this_level;
	int ret, dir = (flags & REVERSE) ? -1 : 1, ofold = case_fold;

	case_fold = (flags & FOLD);
	top_level = &this_level;
	if (setjmp(top_level))
		ret = DSABORT;
	else if (flags & REGEX)
		ret = do_regex_searching(flags, str);
	else if (flags & WORD)
		ret = word_search(dir, str);
	else
		ret = search(dir, str);
	top_level = old_level;
	case_fold = ofold;
	return ret;
}

do_regex_searching(flags, str)
char *str;
{
	int ret, rflags = (flags & REVERSE) ? RE_REVERSE : 0;

	if (regex_first_end)		/* construct flags for */
		rflags |= RE_FIRST_END;	/* regex search from vars */
	if (regex_shortest)
		rflags |= RE_SHORTEST;
	do {
		ret = re_compile(rflags, str) ? DSBAD : re_search(rflags, str);
	} while (ret == 1 && (flags & WORD) &&
		!check_buffer_word(matchstart, matchend));
	return ret;
}

word_search(dir, str)		/* search for whole words only */
char *str;
{
	int before = -1, after = strlen(str);	/* if before string */

	if (dir > 0) {		/* fix offsets to chars before & after word */
		before = -(after + 1);	/* if after string */
		after = 0;
	}
	while (search(dir, str))
		if (!*str || !is_word_char(point + before)
					&& !is_word_char(point + after))
			return 1;
	return 0;
}

check_buffer_word(from, to) /* is this text surrounded by non-word chars? */
{
	int t;
	if (from > to)			/* ensure from <= to */
		t = from, from = to, to = t;
	return !(is_word_char(from - 1) || is_word_char(to));
}

is_word_char(pos)	/* is there a word character in buffer at pos? */
{
	int c = character(pos);

	return isalpha(c) || isdigit(c) || c == '_' || c >= 0x80;
}

fromorig(with)	/* do replace with #0, #1 */
char *with;
{
	int group;
#ifdef BIGREPL		/* this version handles any size replacement string */
	int orig = bufnum, tmp = tmp_buf();

	bufnum = tmp;
	for (; *with; with++) {
		if (*with != '#')
			insert(*with);
		else {
			bufnum = orig;
			group = *++with - '0';
			buf_xfer(tmp, find_group(group, 1),
				find_group(group, 0));
			bufnum = tmp;
		}
	}
	bufnum = orig;
	delete(matchstart, point);
	grab_buffer(tmp);
	buf_delete(tmp);
#else		/* this version quickly handles replacements < 1000 chars */
	char *p, str[1000], *q = str;

	while (*with) {
		p = with;
		if (p)
			p = index(p, '#');
		if (!p) break;
		strncpy(q, with, p - with);	/* add till just before # */
		q += strlen(q);
		if (isdigit(*++p)) {
			group = *p - '0';
			grab(find_group(group, 1), find_group(group, 0), q);
			q += strlen(q);		/* add variable part */
		} else
			*q++ = *p;		/* #x gives x */
		with = p + 1;
	}
	strcpy(q, with);			/* add trailing part */
	delete(matchstart, point);		/* do replacement */
	stuff(str);
#endif
}

col_search(pat, col)		/* go to start of next line w/ string pat */
char *pat;			/* starting in column col */
{				/* return 1 if found, else 0 & go to start */
	int i;

	while (search(1, pat)) {
		i = point;
		point = matchstart;
		if (current_column() == col) {
			if (nl_reverse())
				point++;
			return 1;
		}
		point = i;
	}
	point = 0;
	return 0;
}
